﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Runtime.InteropServices;

namespace JYAG.WebControlInWinforms
{
    //Make the class visible for COM so we can set the ObjectForScripting
    [ComVisible(true)]
    public partial class GeekBrowser : Form
    {
        private string path;

        public GeekBrowser()
        {
            InitializeComponent();
            this.path = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "Webpage");
            InitializeWebBrowser();
        }

        private void InitializeWebBrowser()
        {   
            //set the url to our own html
            this.webBrowser.Url = new Uri(Path.Combine(this.path, "EnableForm.html"));
            
            //set the magic ObjectForScripting to this;
            this.webBrowser.ObjectForScripting = this;

            //Visual settings to integrate the WebBrowser in our Winform.
            this.webBrowser.AllowWebBrowserDrop = false;
            this.webBrowser.WebBrowserShortcutsEnabled = false;
            
            //Comment this line when you are still developing
            this.webBrowser.ScriptErrorsSuppressed = true;
        }

        public void ActivateControls()
        {
            this.firstNameTextBox.Enabled = true;
            this.lastNameTextBox.Enabled = true;
            this.addressTextBox.Enabled = true;
            this.phoneTextBox.Enabled = true;
            this.emailTextBox.Enabled = true;
            this.sendToWebPageButton.Enabled = true;

            this.webBrowser.Url = new Uri(Path.Combine(this.path, "SubsribeToNewsLetter.html"));
        }

        private void sendToWebPageButton_Click(object sender, EventArgs e)
        {
            object[] args = new object[5];
            args[0] = this.firstNameTextBox.Text;
            args[1] = this.lastNameTextBox.Text;
            args[2] = this.addressTextBox.Text;
            args[3] = this.phoneTextBox.Text;
            args[4] = this.emailTextBox.Text;

            this.webBrowser.Document.InvokeScript("fillFields", args);
        }
    }
}
